// CallLogRefMgr.cpp: CCallLogRefMgr NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <algorithm>
#include "CallLogRefMgr.h"
#include "CallLogRefMgrKiller.h"

CCallLogRefMgr* CCallLogRefMgr::m_pInstance = NULL;
CCallLogRefMgrKiller CCallLogRefMgr::m_killer;


CCallLogRefMgr::CCallLogRefMgr()
{
	m_killer.Set(this);
	m_stlCallLogRefList.clear();
}

CCallLogRefMgr::~CCallLogRefMgr()
{
	while(m_stlCallLogRefList.empty()) {
		CCallLogRef* pRef = m_stlCallLogRefList.front();
		if (pRef != NULL) {
			delete pRef;
			pRef = NULL;
		}
		m_stlCallLogRefList.pop_front();
	}
}

CCallLogRefMgr*
CCallLogRefMgr::getInstance()
{
	if (m_pInstance == NULL) {
		try {
			m_pInstance = new CCallLogRefMgr();
		}
		catch(...) {
			m_pInstance = NULL;
		}
	}
	return m_pInstance;
}

CCallLogRef*
CCallLogRefMgr::CreateRef()
{
	CCallLogRef*	pRef = NULL;

	try {
		pRef = new CCallLogRef();
		m_stlCallLogRefList.push_back(pRef);
	}
	catch(...) {
		if (pRef != NULL) {
			delete pRef;
			pRef = NULL;
		}
	}

	return pRef;
}

BOOL
CCallLogRefMgr::DeleteRef(
	CCallLogRef*	pRef
)
{
	BOOL					bRet = FALSE;
	StlCallLogRefListItr	itr;

	if (pRef == NULL) {
		return FALSE;
	}

	itr = std::find(m_stlCallLogRefList.begin(), m_stlCallLogRefList.end(), pRef);
	if (itr != m_stlCallLogRefList.end()) {
		m_stlCallLogRefList.erase(itr);
		delete pRef;
		bRet = TRUE;
	}

	return bRet;
}

BOOL
CCallLogRefMgr::FindRef(
	CCallLogRef* pRef
)
{
	StlCallLogRefListItr	itr;
	BOOL	bRet = FALSE;

	itr = std::find(m_stlCallLogRefList.begin(), m_stlCallLogRefList.end(), pRef);
	if (itr != m_stlCallLogRefList.end()) {
		bRet = TRUE;
	}

	return bRet;
}